
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <poll.h>
#include <signal.h>
#include <unistd.h>
#include <pty.h>
#include <utmp.h>
#include <sys/wait.h>
#include <pthread.h>
#include <string.h>

#include "kindle-keypad.h"

unsigned char key_buf = 0;
unsigned char key_buf_old = 0;
int key_buf_i = 0;
unsigned long key;
int ignore = 0;
static get_selected_func_t get_selected;
struct terminal *pterm;


void key_event( struct input_event *kbe, int stdinput, int eventinput )
{
	static int state[256];
	int i;
	unsigned long key;
	
	if( kbe == NULL ){
		for( i = 0; i < 256; i ++ ) state[ i ] = KEY_UP;
		return;
	}

	if( kbe->value == KEY_UP || kbe->value == KEY_DOWN ){
		state[ kbe->code ] = kbe->value;
	}
	
	{
		static int roulette = 0;
		int roulette_old = 0;
		static unsigned long key_buf = 0;
		static int key_buf_i = 0;
		
		roulette_old = roulette;
		
		if( ( kbe->code == KEYCODE_MENU || kbe->code == KEYCODE_DELETE ) && ( kbe->value == KEY_DOWN || kbe->value == KEY_CONT ) ){
			static enum EVENT roulette_event = EVENT_ROULETTE_KEY;

			roulette = kbe->code;
		
			if( state[ KEYCODE_ALT ] == KEY_DOWN ){
				if( roulette == KEYCODE_MENU ){
					if( key_buf == 0 ) key_buf_i = 0;
					key_buf = alt_menu[ key_buf_i ];
					if( alt_menu[ key_buf_i ] == 0 ){
						key_buf_i = 0;
						key_buf = alt_menu[ key_buf_i ];
					}
				}
				if( roulette == KEYCODE_DELETE ){
					if( key_buf == 0 ) key_buf_i = 0;
					key_buf = alt_del[ key_buf_i ];
					if( alt_del[ key_buf_i ] == 0 ){
						key_buf_i = 0;
						key_buf = alt_del[ key_buf_i ];
					}
				}
				if( roulette ){
					if( !ignore ){
						write( eventinput, &roulette_event, sizeof( enum EVENT ) );
						write( eventinput, &key_buf, sizeof( key_buf ) );
					}
					key_buf_i ++;
					return;
				}
			}
		}
		if( roulette_old && ( roulette != roulette_old || state[ KEYCODE_ALT ] == KEY_UP ) ){
			//printf("Roulette Char %d\n", roulette); fflush( stdout );
			if( !ignore && key_buf ) write( stdinput, &key_buf, 1 );
			key_buf_i = 0;
			key_buf = 0;
			roulette = 0;
		}
	}
	if( pterm->decpm[DECPM_ApplicationCursorKeys] || pterm->decpm[DECPM_UseAlternateScreenBuffer] ){
		for( i = 0; appcur_event_key[ i ].event != EVENT_MAX; i ++ ){
			if( appcur_event_key[ i ].code != kbe->code ) continue;
			if( appcur_event_key[ i ].type != kbe->value ) continue;
			if( appcur_event_key[ i ].pressed[0] && state[ appcur_event_key[ i ].pressed[0] ] == KEY_UP ) continue;
			if( appcur_event_key[ i ].pressed[1] && state[ appcur_event_key[ i ].pressed[1] ] == KEY_UP ) continue;
			if( appcur_event_key[ i ].unpressed && state[ appcur_event_key[ i ].unpressed ] == KEY_DOWN ) continue;
			if( appcur_event_key[ i ].event != EVENT_SPECIAL_CHARACTOR ){
				// appcur_event_key event
				//printf("AppCur Event: %d\n",event_key[ i ].event); fflush( stdout );
				write( eventinput, &appcur_event_key[ i ].event, sizeof( enum EVENT ) );
			}else{
				// Special character
				//printf("Char\n"); fflush( stdout );
				//printf("ApplicationCursor Char %d\n", i); fflush( stdout );
				if( !ignore ){
					int len;
					len = strlen( appcur_event_key[ i ].str );
					if( len < 1 ) len = 1;
					write( stdinput, appcur_event_key[ i ].str, len );
				}
			}
			key = 0;
			return;
		}
	}
	if( pterm->decpm[DECPM_ApplicationKeypad] ){
		for( i = 0; appkey_event_key[ i ].event != EVENT_MAX; i ++ ){
			if( appkey_event_key[ i ].code != kbe->code ) continue;
			if( appkey_event_key[ i ].type != kbe->value ) continue;
			if( appkey_event_key[ i ].pressed[0] && state[ appkey_event_key[ i ].pressed[0] ] == KEY_UP ) continue;
			if( appkey_event_key[ i ].pressed[1] && state[ appkey_event_key[ i ].pressed[1] ] == KEY_UP ) continue;
			if( appkey_event_key[ i ].unpressed && state[ appkey_event_key[ i ].unpressed ] == KEY_DOWN ) continue;
			if( appkey_event_key[ i ].event != EVENT_SPECIAL_CHARACTOR ){
				// appcur_event_key event
				//printf("AppKey Event: %d\n",event_key[ i ].event); fflush( stdout );
				write( eventinput, &appkey_event_key[ i ].event, sizeof( enum EVENT ) );
			}else{
				// Special character
				//printf("ApplicationKeypad Char %d\n", i); fflush( stdout );
				if( !ignore ){
					int len;
					len = strlen( appkey_event_key[ i ].str );
					if( len < 1 ) len = 1;
					write( stdinput, appkey_event_key[ i ].str, len );
				}
			}
			key = 0;
			return;
		}
	}
	for( i = 0; event_key[ i ].event != EVENT_MAX; i ++ ){
		if( event_key[ i ].code != kbe->code ) continue;
		if( event_key[ i ].type != kbe->value ) continue;
		if( event_key[ i ].pressed[0] && state[ event_key[ i ].pressed[0] ] == KEY_UP ) continue;
		if( event_key[ i ].pressed[1] && state[ event_key[ i ].pressed[1] ] == KEY_UP ) continue;
		if( event_key[ i ].unpressed && state[ event_key[ i ].unpressed ] == KEY_DOWN ) continue;
		if( event_key[ i ].event == EVENT_SUBCURSOR_CLICK ){
			unsigned long *pos;
			int len;
			int i;
			
			pos = (*get_selected)( &len );
			
			for( i = 0; i < len; i ++ ){
				if( pos[ i ] < 0x80 ){
					if( pos[ i ] != 0 ){
						if( !ignore ) write( stdinput, &pos[ i ], 1 );
					}
				}else{
					unsigned char utf[8];
					int j;
					unsigned long code;
					unsigned char last;
			
					last = 0;
					code = pos[ i ];
					for( j = 7; j >= 0; j -- ){
						utf[ j ] = 0x80 | ( code & 0x3F );
						code = code >> 6;
						last = last >> 1;
						last |= 0x80;
						if( code == 0 ) break;
					}
					if( j < 1 ) continue;
					if( ( 0x80 >> ( 8 - j ) ) > ( utf[ j ] & 0x3F ) ){
						utf[ j ] |= last;
					}else{
						last = last >> 1;
						last |= 0x80;
						j ++;
						utf[ j ] = last;
					}
					if( !ignore ) write( stdinput, &utf[ j ], ( 8 - j ) );
				}
			}
		}else if( event_key[ i ].event != EVENT_SPECIAL_CHARACTOR ){
			// Terminal event
			//printf("Event: %d\n",event_key[ i ].event); fflush( stdout );
			write( eventinput, &event_key[ i ].event, sizeof( enum EVENT ) );
		}else{
			// Special character
			//printf("Char %d (%d)\n", i, strlen( event_key[ i ].str )); fflush( stdout );
			if( !ignore ){
				int len;
				len = strlen( event_key[ i ].str );
				if( len < 1 ) len = 1;
				write( stdinput, event_key[ i ].str, len );
			}
		}
		key = 0;
		return;
	}
	
	// Mapping
	key = keycode[ kbe->code ];
	if( ( state[ KEYCODE_SHIFT ] == KEY_DOWN || 
		  state[ KEYCODE_HOME ] == KEY_DOWN ) && 'a' <= key && key <= 'z' ){
		key += (char)((int)'A' - (int)'a');
	}else if( state[ KEYCODE_SHIFT ] == KEY_DOWN && shifts[ key ] ){
		key = shifts[ key ];
	}else if( state[ KEYCODE_CTRL ] && 'a' <= key && key <= 'z' ){
		key = 1 + key - 'a';
	}else if( state[ KEYCODE_SYM ] && symbols[ key ] ){
		key = symbols[ key ];
	}else if( state[ KEYCODE_ALT ] && alts[ key ] ){
		key = alts[ key ];
	}
	
	if( key != 0 && ( kbe->value == KEY_DOWN || kbe->value == KEY_CONT ) ){
		//printf("%x\n",key);
		if( !ignore ) write( stdinput, &key, 1 );
	}
}


void *key_poller_therad( void *data )
{
	fd_set key_rfds;
	
	int kb;
	int fw;
	int vol;
	int stdinput;
	int eventinput;

	int fd_max;

	stdinput = ((int*)data)[0];
	eventinput = ((int*)data)[1];

	kb =  open( "/dev/input/event0", O_RDONLY );
	if( kb == -1 ) return 0;
	fw =  open( "/dev/input/event1", O_RDONLY );
	if( fw == -1 ) return 0;
	vol = open( "/dev/input/event2", O_RDONLY );
	if( vol == -1 ) return 0;
	
	key_event( NULL, stdinput, eventinput );

	fd_max = kb;
	if( fd_max < fw )  fd_max = fw;
	if( fd_max < vol ) fd_max = vol;
	fd_max ++;

	while( 1 ){
		FD_ZERO( &key_rfds );
		FD_SET( kb, &key_rfds );
		FD_SET( fw, &key_rfds );
		FD_SET( vol, &key_rfds );
		//printf("+++\n");
		if( select( fd_max, &key_rfds, NULL, NULL, NULL ) > 0 ){
			struct input_event kbe;
			if( FD_ISSET( fw, &key_rfds ) ){
				read( fw, &kbe, sizeof( kbe ) );
				key_event( &kbe, stdinput, eventinput );
			}
			if( FD_ISSET( kb, &key_rfds ) ){
				read( kb, &kbe, sizeof( kbe ) );
				key_event( &kbe, stdinput, eventinput );
			}
			if( FD_ISSET( vol, &key_rfds ) ){
				read( vol, &kbe, sizeof( kbe ) );
				key_event( &kbe, stdinput, eventinput );
			}
		}
	}
}

int kkeypad_init( int out, get_selected_func_t get_selected_f, struct terminal *term )
{
	pthread_t key_poller;
	int pfd[2];
	int *output;
	
	pterm = term;
	get_selected = get_selected_f;
	pipe( pfd );
	
	output = malloc( sizeof( int ) * 2 );
	output[0] = out;
	output[1] = pfd[1];
	pthread_create( &key_poller, NULL, key_poller_therad, output );
	pthread_detach( key_poller );
	
	return pfd[0];
}

void kkeypad_ignore( int state )
{
	ignore = state;
}
